diff -ruN qmail-1.03-orig/qmail-verify.c qmail-1.03-ldap-20060201-orig/qmail-verify.c
--- qmail-1.03-orig/qmail-verify.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qmail-verify.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,445 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <pwd.h>
+#include <unistd.h>
+#include "auto_break.h"
+#include "byte.h"
+#include "case.h"
+#include "cdb.h"
+#include "error.h"
+#include "getln.h"
+#include "localdelivery.h"
+#include "open.h"
+#include "output.h"
+#include "qldap.h"
+#include "qldap-debug.h"
+#include "qldap-errno.h"
+#include "qmail-ldap.h"
+#include "read-ctrl.h"
+#include "str.h"
+#include "stralloc.h"
+#include "subfd.h"
+#include "substdio.h"
+#include "timeoutread.h"
+
+struct qldap *q;
+
+void cleanup(void);
+void
+die_read(void)
+{
+	cleanup();
+	_exit(1);
+}
+void
+die_write(void)
+{
+	cleanup();
+	_exit(1);
+}
+void
+die_nomem(void)
+{
+	cleanup();
+	if (substdio_puts(subfdout, "ZOut of memory in qmail-verify.") == -1)
+		die_write();
+	if (substdio_putflush(subfdout, "", 1) == -1)
+		die_write();
+	_exit(111);
+}
+void
+die_timeout(void)
+{
+	cleanup();
+	_exit(111);
+}
+void
+die_temp(void)
+{
+	cleanup();
+	_exit(111);
+}
+void
+die_control(void)
+{
+	_exit(100);
+}
+void
+temp_fail(void)
+{
+	if (substdio_putflush(subfdout, "Z", 2) == -1)
+		die_write();
+	qldap_free_results(q);
+}
+
+int
+temp_sys(void)
+{
+	if (substdio_puts(subfdout,
+	    "ZTemporary failure in qmail-verify.") == -1)
+		die_write();
+	if (substdio_putflush(subfdout, "", 1) == -1)
+		die_write();
+	return -1;
+}
+
+int
+temp_nfs(void)
+{
+	if (substdio_puts(subfdout, "ZNFS failure in qmail-verify.") == -1)
+		die_write();
+	if (substdio_putflush(subfdout, "", 1) == -1)
+		die_write();
+	return -1;
+}
+
+void
+die_cdb(void)
+{
+	if (substdio_puts(subfdout,
+	    "ZTrouble reading users/cdb in qmail-verify.") == -1)
+		die_write();
+	if (substdio_putflush(subfdout, "", 1) == -1)
+		die_write();
+	_exit(111);
+}
+
+int lookup(stralloc *);
+int lookup_cdb(const char *);
+int lookup_passwd(const char *);
+
+
+int timeout = 5;
+int
+saferead(int fd, void *buf, int len)
+{
+	return timeoutread(timeout,fd,buf,len);
+}
+
+char ssinbuf[512];
+substdio ssin = SUBSTDIO_FDBUF(saferead,0,ssinbuf,sizeof ssinbuf);
+
+stralloc line = {0};
+ctrlfunc	ctrls[] = {
+		qldap_ctrl_trylogin,
+		qldap_ctrl_generic,
+		localdelivery_init,
+		0 };
+
+int
+main(int argc, char **argv)
+{
+	int match;
+	unsigned int at;
+
+	log_init(STDERR, ~256, 0);
+
+	if (read_controls(ctrls) == -1)
+		die_control();
+	
+	q = 0;
+	do {
+		if (getln(&ssin, &line, &match, '\0') != 0) {
+			if (errno != error_timeout)
+				die_read();
+			cleanup();
+			continue;
+		}
+		if (!match) {
+			cleanup(); /* other side closed pipe */
+			break;
+		}
+
+		logit(32, "qmail-verfiy: verifying %S\n", &line);
+
+		at = byte_rchr(line.s,line.len,'@');
+		if (at >= line.len) {
+			if (substdio_puts(subfdout, "DSorry, address must "
+			    "include host name. (#5.1.3)") == -1)
+				die_write();
+			if (substdio_putflush(subfdout, "", 1) == -1)
+				die_write();
+			continue;
+		}
+
+		switch (lookup(&line)) {
+		case 0:
+			if (localdelivery()) {
+				/*
+				 * Do the local address lookup.
+				 */
+				line.s[at] = '\0';
+				if (lookup_cdb(line.s) == 1)
+					break;
+				if (lookup_passwd(line.s) == 1)
+					break;
+			}
+			/* Sorry, no mailbox here by that name. */
+			if (substdio_puts(subfdout,
+			    "DSorry, no mailbox here by that name. "
+			    "(#5.1.1)") == -1)
+				die_write();
+			if (substdio_putflush(subfdout, "", 1) == -1)
+				die_write();
+			break;
+		case 1:
+		default:
+			break;
+		}
+	} while (1);
+
+	return 0;
+}
+
+int
+lookup(stralloc *mail)
+{
+	const char *attrs[] = {  LDAP_ISACTIVE, 0 };
+	char *f;
+	int done;
+	int status;
+	int rv;
+
+	if (q == 0) {
+		q = qldap_new();
+		if (q == 0)
+			die_nomem();
+
+		rv = qldap_open(q);
+		if (rv != OK) die_temp();
+		rv = qldap_bind(q, 0, 0);
+		if (rv != OK) die_temp();
+	}
+	
+	/*
+	 * this handles the "catch all" and "-default" extension 
+	 * but also the normal eMail address.
+	 * Code handels also mail addresses with multiple '@' safely.
+	 * at = index to last @ sign in mail address
+	 * escaped = ldap escaped mailaddress
+	 * len = length of escaped mailaddress
+	 * i = position of current '-' or '@'
+	 */
+	done = 0;
+	do {
+		f = filter_mail(mail->s, &done);
+		if (f == (char *)0) die_nomem();
+
+		logit(16, "ldapfilter: '%s'\n", f);
+
+		/* do the search for the email address */
+		rv = qldap_lookup(q, f, attrs);
+		switch (rv) {
+		case OK:
+			break; /* something found */
+		case TIMEOUT:
+			/* temporary error but give up so that the
+			 * ldap server can recover */
+			die_timeout();
+		case TOOMANY:
+#ifdef DUPEALIAS
+			if (substdio_putflush(subfdout, "K", 1) == -1)
+				die_write();
+			qldap_free_results(q);
+#else
+			/* admin error, also temporary */
+			temp_fail();
+#endif
+			return (-1);
+		case FAILED:
+			/* ... again temporary */
+			temp_fail();
+			return (-1);
+		case NOSUCH:
+			break;
+		}
+	} while (rv != OK && !done);
+	/* reset filter_mail */
+	filter_mail(0, 0);
+
+	/* nothing found, try a local lookup or a alias delivery */
+	if (rv == NOSUCH) {
+		qldap_free_results(q);
+		return (0);
+	}
+
+	/* check if the ldap entry is active */
+	rv = qldap_get_status(q, &status);
+	if (rv != OK) {
+		temp_fail();
+		return (-1);
+	}
+	if (status == STATUS_BOUNCE) {
+		/* Mailaddress is administratively disabled. (#5.2.1) */
+		if (substdio_puts(subfdout,
+			    "DMailaddress is administratively disabled. "
+			    "(#5.2.1)") == -1)
+			die_write();
+		if (substdio_putflush(subfdout, "", 1) == -1)
+			die_write();
+		qldap_free_results(q);
+		return (1);
+	} else if (status == STATUS_DELETE) {
+		/* Sorry, no mailbox here by that name. (#5.1.1) */
+		if (substdio_puts(subfdout,
+			    "DSorry, no mailbox here by that name. "
+			    "(#5.1.1)") == -1)
+			die_write();
+		if (substdio_putflush(subfdout, "", 1) == -1)
+			die_write();
+		qldap_free_results(q);
+		return (1);
+	}
+
+	/* OK */
+	if (substdio_putflush(subfdout, "K", 1) == -1)
+		die_write();
+	qldap_free_results(q);
+	return (1);
+}
+
+void
+cleanup(void)
+{
+	if (q != 0)
+		qldap_free(q);
+	q = 0;
+}
+
+stralloc lower = {0};
+stralloc wildchars = {0};
+struct cdb cdb;
+
+int
+lookup_cdb(const char *mail)
+{
+	int	fd;
+	int	flagwild;
+	int	r;
+
+	if (!stralloc_copys(&lower, "!")) die_nomem();
+	if (!stralloc_cats(&lower, mail)) die_nomem();
+	if (!stralloc_0(&lower)) die_nomem();
+	case_lowerb(lower.s, lower.len);
+
+	fd = open_read("users/cdb");
+	if (fd == -1)
+		if (errno != error_noent)
+			die_cdb();
+
+	if (fd != -1) {
+		uint32 dlen;
+		unsigned int i;
+
+		cdb_init(&cdb, fd);
+		r = cdb_seek(&cdb, "", 0, &dlen);
+		if (r != 1)
+			die_cdb();
+
+		if (!stralloc_ready(&wildchars, (unsigned int) dlen))
+			die_nomem();
+		wildchars.len = dlen;
+		if (cdb_bread(&cdb, wildchars.s, wildchars.len) == -1)
+			die_cdb();
+
+		i = lower.len;
+		flagwild = 0;
+
+		do {
+			/* i > 0 */
+			if (!flagwild || i == 1 || byte_chr(wildchars.s,
+			    wildchars.len, lower.s[i - 1]) < wildchars.len) {
+				r = cdb_seek(&cdb,lower.s,i,&dlen);
+				if (r == -1)
+					die_cdb();
+				if (r == 1) {
+					/* OK */
+					if (substdio_putflush(subfdout, "K",
+					    1) == -1)
+						die_write();
+					
+					cdb_free(&cdb);
+					close(fd);
+					return (1);
+				}
+			}
+			--i;
+			flagwild = 1;
+		} while (i);
+
+		close(fd);
+	}
+	return (0);
+}
+
+#define GETPW_USERLEN 32
+
+int
+lookup_passwd(const char *local)
+{
+	char username[GETPW_USERLEN];
+	struct stat st;
+	const char *extension;
+	struct passwd *pw;
+
+
+	extension = local + str_len(local);
+	for (; extension >= local; extension--) {
+		if ((unsigned long)(extension - local) < sizeof(username))
+			if (!*extension || (*extension == *auto_break)) {
+				byte_copy(username, extension - local, local);
+				username[extension - local] = 0;
+				case_lowers(username);
+				errno = 0;
+				pw = getpwnam(username);
+				if (errno == error_txtbsy)
+					return temp_sys();
+				if (pw && pw->pw_uid != 0) {
+					if (stat(pw->pw_dir,&st) == 0 &&
+					    st.st_uid == pw->pw_uid) {
+						/* OK */
+						if (substdio_putflush(subfdout,
+						    "K", 1) == -1)
+							die_write();
+						return (1);
+					} else if (error_temp(errno))
+						return temp_nfs();
+				}
+			}
+	}
+	return (0);
+}
+
diff -ruN qmail-1.03-orig/qreceipt.c qmail-1.03-ldap-20060201-orig/qreceipt.c
--- qmail-1.03-orig/qreceipt.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qreceipt.c	2006-02-25 11:00:56.000000000 +0100
@@ -60,7 +60,7 @@
 
 void finishheader()
 {
- char *qqx;
+ const char *qqx;
 
  if (!flagreceipt) die_noreceipt();
  if (str_equal(returnpath,"")) die_noreceipt();
@@ -92,9 +92,10 @@
  qmail_to(&qqt,returnpath);
  qqx = qmail_close(&qqt);
 
- if (*qqx)
+ if (*qqx) {
    if (*qqx == 'D') die_qqperm();
    else die_qqtemp();
+ }
 }
 
 stralloc hfbuf = {0};
@@ -119,7 +120,7 @@
 
 void dobody(h) stralloc *h; { ; }
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -128,4 +129,6 @@
  if (!(returnpath = env_get("SENDER"))) die_usage();
  if (headerbody(subfdin,doheaderfield,finishheader,dobody) == -1) die_read();
  die_noreceipt();
+ /* NOTREACHED */
+ return 0;
 }
diff -ruN qmail-1.03-orig/qsmhook.c qmail-1.03-ldap-20060201-orig/qsmhook.c
--- qmail-1.03-orig/qsmhook.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qsmhook.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,3 +1,4 @@
+#include <unistd.h>
 #include "fd.h"
 #include "stralloc.h"
 #include "readwrite.h"
@@ -35,7 +36,7 @@
 substdio ssin;
 char inbuf[SUBSTDIO_INSIZE];
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -45,7 +46,7 @@
  int opt;
  char **arg;
  char *x;
- int i;
+ unsigned int i;
  int flagesc;
 
  sig_pipeignore();
@@ -78,7 +79,7 @@
 
  if (!*argv) die_usage();
 
- for (arg = argv;x = *arg;++arg)
+ for (arg = argv;(x = *arg);++arg)
   {
    if (!stralloc_copys(&newarg,"")) die_temp();
    flagesc = 0;
@@ -122,8 +123,8 @@
   }
  close(pi[0]);
 
- substdio_fdbuf(&ssout,write,pi[1],outbuf,sizeof(outbuf));
- substdio_fdbuf(&ssin,read,0,inbuf,sizeof(inbuf));
+ substdio_fdbuf(&ssout,subwrite,pi[1],outbuf,sizeof(outbuf));
+ substdio_fdbuf(&ssin,subread,0,inbuf,sizeof(inbuf));
  if (flagufline) substdio_bputs(&ssout,ufline);
  if (flagrpline) substdio_bputs(&ssout,rpline);
  if (flagdtline) substdio_bputs(&ssout,dtline);
@@ -133,5 +134,5 @@
 
  if (wait_pid(&wstat,pid) == -1) die_temp();
  if (wait_crashed(wstat)) die_temp();
- _exit(wait_exitcode(wstat));
+ return wait_exitcode(wstat);
 }
diff -ruN qmail-1.03-orig/qsutil.c qmail-1.03-ldap-20060201-orig/qsutil.c
--- qmail-1.03-orig/qsutil.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qsutil.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,3 +1,4 @@
+#include <unistd.h>
 #include "stralloc.h"
 #include "readwrite.h"
 #include "substdio.h"
@@ -6,22 +7,22 @@
 static stralloc foo = {0};
 
 static char errbuf[1];
-static struct substdio sserr = SUBSTDIO_FDBUF(write,0,errbuf,1);
+static struct substdio sserr = SUBSTDIO_FDBUF(subwrite,0,errbuf,1);
 
 void logsa(sa) stralloc *sa; {
  substdio_putflush(&sserr,sa->s,sa->len); }
-void log1(s1) char *s1; {
+void log1(s1) const char *s1; {
  substdio_putsflush(&sserr,s1); }
-void log2(s1,s2) char *s1; char *s2; {
+void log2(s1,s2) const char *s1; const char *s2; {
  substdio_putsflush(&sserr,s1);
  substdio_putsflush(&sserr,s2); }
-void log3(s1,s2,s3) char *s1; char *s2; char *s3; {
+void log3(s1,s2,s3) const char *s1; const char *s2; const char *s3; {
  substdio_putsflush(&sserr,s1);
  substdio_putsflush(&sserr,s2);
  substdio_putsflush(&sserr,s3); }
-void nomem() { log1("alert: out of memory, sleeping...\n"); sleep(10); }
+void nomem(void) { log1("alert: out of memory, sleeping...\n"); sleep(10); }
 
-void pausedir(dir) char *dir;
+void pausedir(dir) const char *dir;
 { log3("alert: unable to opendir ",dir,", sleeping...\n"); sleep(10); }
 
 static int issafe(ch) char ch;
@@ -32,11 +33,11 @@
  return 1;
 }
 
-void logsafe(s) char *s;
+void logsafe(s) const char *s;
 {
- int i;
+ unsigned int i;
  while (!stralloc_copys(&foo,s)) nomem();
- for (i = 0;i < foo.len;++i)
+ for (i = 0; i < foo.len;++i)
    if (foo.s[i] == '\n')
      foo.s[i] = '/';
    else
diff -ruN qmail-1.03-orig/qsutil.h qmail-1.03-ldap-20060201-orig/qsutil.h
--- qmail-1.03-orig/qsutil.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qsutil.h	2006-02-25 11:00:56.000000000 +0100
@@ -1,12 +1,12 @@
 #ifndef QSUTIL_H
 #define QSUTIL_H
 
-extern void log1();
-extern void log2();
-extern void log3();
-extern void logsa();
-extern void nomem();
-extern void pausedir();
-extern void logsafe();
+extern void log1(const char *);
+extern void log2(const char *, const char *);
+extern void log3(const char *, const char *, const char *);
+extern void logsa(stralloc *);
+extern void nomem(void);
+extern void pausedir(const char *);
+extern void logsafe(const char *);
 
 #endif
diff -ruN qmail-1.03-orig/quote.c qmail-1.03-ldap-20060201-orig/quote.c
--- qmail-1.03-orig/quote.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/quote.c	2006-02-25 11:00:56.000000000 +0100
@@ -9,7 +9,7 @@
 no special encoding here for bytes above 127.
 */
 
-static char ok[128] = {
+static const char ok[128] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 ,0,7,0,7,7,7,7,7,0,0,7,7,0,7,7,7 ,7,7,7,7,7,7,7,7,7,7,0,0,0,7,0,7
 ,0,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7 ,7,7,7,7,7,7,7,7,7,7,7,0,0,0,7,7
@@ -21,8 +21,8 @@
 stralloc *sain;
 {
  char ch;
- int i;
- int j;
+ unsigned int i;
+ unsigned int j;
 
  if (!stralloc_ready(saout,sain->len * 2 + 2)) return 0;
  j = 0;
@@ -40,11 +40,11 @@
 }
 
 int quote_need(s,n)
-char *s;
+const char *s;
 unsigned int n;
 {
  unsigned char uch;
- int i;
+ unsigned int i;
  if (!n) return 1;
  for (i = 0;i < n;++i)
   {
@@ -70,9 +70,9 @@
 
 int quote2(sa,s)
 stralloc *sa;
-char *s;
+const char *s;
 {
- int j;
+ unsigned int j;
  if (!*s) return stralloc_copys(sa,s);
  j = str_rchr(s,'@');
  if (!stralloc_copys(&foo,s)) return 0;
diff -ruN qmail-1.03-orig/quote.h qmail-1.03-ldap-20060201-orig/quote.h
--- qmail-1.03-orig/quote.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/quote.h	2006-02-25 11:00:56.000000000 +0100
@@ -1,8 +1,10 @@
 #ifndef QUOTE_H
 #define QUOTE_H
 
-extern int quote_need();
-extern int quote();
-extern int quote2();
+#include "stralloc.h"
+
+extern int quote_need(const char *, unsigned int);
+extern int quote(stralloc *, stralloc *);
+extern int quote2(stralloc *, const char *);
 
 #endif
diff -ruN qmail-1.03-orig/rbl.c qmail-1.03-ldap-20060201-orig/rbl.c
--- qmail-1.03-orig/rbl.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/rbl.c	2006-02-25 11:00:56.000000000 +0100
@@ -0,0 +1,261 @@
+/*
+ * Copyright (c) 2002-2004 Andre Oppermann,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include "alloc.h"
+#include "control.h"
+#include "dns.h"
+#include "env.h"
+#include "ipalloc.h"
+#include "qmail.h"
+#include "str.h"
+#include "stralloc.h"
+
+#include "rbl.h"
+
+static stralloc rblmessage = {0};
+int rblprintheader = 0;
+
+/* functions borrowed from qmail-smtpd.c */
+extern void safeput();
+extern void die_nomem();
+
+extern void logpid();
+extern void logline();
+extern void logstring();
+extern void logflush();
+
+void rblheader(struct qmail *qqt)
+{
+  if (!rblprintheader) return;
+  /* rblmessage is safe because it does not contain any remote info */
+  if (rblmessage.s) qmail_put(qqt,rblmessage.s,rblmessage.len);
+}
+
+struct rbl {
+  char *baseaddr;
+  char *action;
+  char *matchon;
+  char *message;
+} *rbl;
+
+unsigned int numrbl;
+
+static stralloc ip_reverse = {0};
+static stralloc rbl_tmp = {0};
+
+static int rbl_start(const char *remoteip)
+{
+  unsigned int i;
+  unsigned int j;
+  const char *ip_env;
+
+  ip_env = remoteip;
+  if (!ip_env) ip_env = "";
+
+  if (!stralloc_copys(&ip_reverse,"")) die_nomem();
+
+  i = str_len(ip_env);
+  while (i) {
+    for (j = i;j > 0;--j) {
+      if (ip_env[j - 1] == '.') break;
+      if (ip_env[j - 1] == ':') return 0; /* no IPv6 */
+    }
+    if (!stralloc_catb(&ip_reverse,ip_env + j,i - j)) die_nomem();
+    if (!stralloc_cats(&ip_reverse,".")) die_nomem();
+    if (!j) break;
+    i = j - 1;
+  }
+  return 1;
+}
+
+static char ipstr[IPFMT];
+
+static int rbl_lookup(char *base, char *matchon)
+{
+  ipalloc rblsa = {0};
+  unsigned int i;
+
+  if (!*base) return 2;
+
+  if (!stralloc_copy(&rbl_tmp,&ip_reverse)) die_nomem();
+  if (!stralloc_cats(&rbl_tmp,base)) die_nomem();
+
+  switch (dns_ip(&rblsa,&rbl_tmp)) {
+    case DNS_MEM:
+    case DNS_SOFT:
+      return 2; /* soft error */
+    case DNS_HARD:
+      return 0; /* found no match */
+    default: /* found match */
+      if (!str_diff("any", matchon))
+        return 1;
+      for (i = 0;i < rblsa.len;++i)
+      {
+	ipstr[ip_fmt(ipstr,&rblsa.ix[i].ip)]=0;
+	if (!str_diff(ipstr, matchon)) return 1;
+      }
+      return 0; /* found match but ignored */
+  }
+  return 1; /* should never get here */
+}
+
+void rbladdheader(char *base, char *matchon, char *message)
+{
+  /* all of base, matchon and message can be trusted because these
+     are under our control */
+  rblprintheader = 1;
+  if(!stralloc_cats(&rblmessage, "X-RBL: (")) die_nomem();
+  if(!stralloc_cats(&rblmessage, base)) die_nomem();
+  if(!stralloc_cats(&rblmessage, ") ")) die_nomem();
+  if (str_diff("any", matchon)) {
+    if(!stralloc_cats(&rblmessage, "matches with ")) die_nomem();
+    if(!stralloc_cats(&rblmessage, matchon)) die_nomem();
+    if(!stralloc_cats(&rblmessage, " and ")) die_nomem();
+  }
+  if(!stralloc_cats(&rblmessage, "tells us ")) die_nomem();
+  if(!stralloc_cats(&rblmessage, message)) die_nomem();
+  if(!stralloc_cats(&rblmessage, "\n")) die_nomem();
+}
+
+void
+rbllog(int level, const char* baseaddr, const char *msg)
+{
+	logpid(level);
+	logstring(level, "RBL check with '");
+	logstring(level, baseaddr);
+	logstring(level, "': ");
+	logstring(level, msg);
+        logflush(level);
+}
+
+int rblcheck(const char *remoteip, char** rblname, int rbloh)
+{
+  int r = 1;
+  unsigned int i;
+
+  if(!stralloc_copys(&rblmessage, "")) die_nomem();
+  if(!rbl_start(remoteip)) return 0;
+
+  for (i=0; i < numrbl; i++) {
+    r = rbl_lookup(rbl[i].baseaddr, rbl[i].matchon);
+
+    if (r == 2) {
+      rbllog(3,rbl[i].baseaddr, "temporary DNS error, ignored");
+    } else if (r == 1) {
+      *rblname = rbl[i].message;
+      if (rbloh) {
+        rbllog(3,rbl[i].baseaddr, "found match, tag header");
+	rbladdheader(rbl[i].baseaddr, rbl[i].matchon, rbl[i].message);
+	continue;
+      }
+      if (!str_diff("addheader", rbl[i].action)) {
+        rbllog(3,rbl[i].baseaddr, "found match, tag header");
+	rbladdheader(rbl[i].baseaddr, rbl[i].matchon, rbl[i].message);
+	continue;
+      } else {
+	/* default reject */
+        rbllog(2,rbl[i].baseaddr, "found match, reject sender");
+	rblprintheader = 0;
+	return 1;
+      }
+    }
+    /* continue */
+    rbllog(3,rbl[i].baseaddr, "no match found, continue.");
+  }
+  return 0; /* either tagged, soft error or allowed */
+}
+
+stralloc rbldata = {0};
+
+int rblinit(void)
+{
+  char** x;
+  int on;
+  unsigned int i;
+  unsigned int j;
+  unsigned int k;
+  unsigned int n;
+
+  on = control_readfile(&rbldata,"control/rbllist",0);
+  if (on == -1) return on;
+  if (!on) return on;
+
+  for(i=0, numrbl=0; i < rbldata.len; ++i)
+    if (rbldata.s[i] == '\0')
+	++numrbl;
+
+  rbl = (struct rbl*)alloc(numrbl*sizeof(struct rbl));
+  if (!rbl) return -1;
+
+  /* line format is "basedomain action matchon message"
+     message may have spaces */
+  x = (char **)&rbl[0];
+  for (i=0, j=0, k=0, n=0; i < rbldata.len; ++i) {
+    while (1) {
+      /* hop over spaces */
+      if (rbldata.s[i] != ' ' && rbldata.s[i] != '\t') break;
+      if (rbldata.s[i] == '\0') {
+	logline(1, "parse error in rbllist, unexpected end of line");
+	return -1;
+      }
+      i++;
+    }
+    j = i;
+    if (n == 3) {
+      /* message */
+      x[n] = rbldata.s + j;
+      n = 0;
+      x = (char **)&rbl[++k];
+      while (rbldata.s[i] != '\0') i++;
+    } else {
+      while (1) {
+        /* hop over argument */
+        if (rbldata.s[i] == ' ' || rbldata.s[i] == '\t') break;
+        if (rbldata.s[i] == '\0') {
+	  logline(1, "parse error in rbllist, unexpected end of line");
+	  return -1;
+        }
+        i++;
+      }
+      rbldata.s[i] = '\0';
+      x[n++] = rbldata.s + j;
+    }
+  }
+  if (k != numrbl) {
+    logline(1,"parse error in rbllist, unexpected end of file");
+    return -1;
+  }
+
+  return 1; /* everything fine */
+}
+
diff -ruN qmail-1.03-orig/rbl.h qmail-1.03-ldap-20060201-orig/rbl.h
--- qmail-1.03-orig/rbl.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/rbl.h	2006-02-25 11:00:56.000000000 +0100
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2002-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef RBL_H
+#define RBL_H
+
+#include "qmail.h"
+
+extern void rblheader(struct qmail *);
+extern int rblcheck(const char *, char **, int);
+extern int rblinit(void);
+
+#endif
diff -ruN qmail-1.03-orig/rcpthosts.c qmail-1.03-ldap-20060201-orig/rcpthosts.c
--- qmail-1.03-orig/rcpthosts.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/rcpthosts.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,5 +1,6 @@
 #include "cdb.h"
 #include "byte.h"
+#include "case.h"
 #include "open.h"
 #include "error.h"
 #include "control.h"
@@ -7,54 +8,126 @@
 #include "stralloc.h"
 #include "rcpthosts.h"
 
-static int flagrh = 0;
+static int flagrh = -1;
 static stralloc rh = {0};
 static struct constmap maprh;
+static int fdlo;
+static int fdrh;
 static int fdmrh;
+static struct cdb cdblo;
+static struct cdb cdbrh;
+static struct cdb cdbmrh;
+static stralloc locals = {0};
+static struct constmap maplocals;
 
-int rcpthosts_init()
+int rcpthosts_init(void)
 {
-  flagrh = control_readfile(&rh,"control/rcpthosts",0);
-  if (flagrh != 1) return flagrh;
-  if (!constmap_init(&maprh,rh.s,rh.len,0)) return flagrh = -1;
-  fdmrh = open_read("control/morercpthosts.cdb");
-  if (fdmrh == -1) if (errno != error_noent) return flagrh = -1;
-  return 0;
+	fdlo = open_read("control/locals.cdb");
+	if (fdlo == -1) {
+		if (errno != error_noent)
+			return -1;
+		if (control_readfile(&locals,"control/locals",1) != 1)
+			return -1;
+		if (!constmap_init(&maplocals,locals.s,locals.len,0))
+			return -1;
+	} else
+		cdb_init(&cdblo, fdlo);
+
+	fdrh = open_read("control/rcpthosts.cdb");
+	if (fdrh == -1) {
+		if (errno != error_noent) return -1;
+
+		if (control_readfile(&rh,"control/rcpthosts",0) == -1)
+			return -1;
+		if (!constmap_init(&maprh,rh.s,rh.len,0))
+			return -1;
+		fdmrh = open_read("control/morercpthosts.cdb");
+		if (fdmrh == -1) {
+			if (errno != error_noent)
+				return -1;
+		} else
+			cdb_init(&cdbmrh, fdmrh);
+	} else
+		cdb_init(&cdbrh, fdrh);
+
+	flagrh = 1;
+	return 0;
 }
 
 static stralloc host = {0};
 
-int rcpthosts(buf,len)
-char *buf;
-int len;
+int localhosts(char *buf, unsigned int len)
 {
-  int j;
-
-  if (flagrh != 1) return 1;
-
-  j = byte_rchr(buf,len,'@');
-  if (j >= len) return 1; /* presumably envnoathost is acceptable */
-
-  ++j; buf += j; len -= j;
+	unsigned int j;
+	uint32 dlen;
 
-  if (!stralloc_copyb(&host,buf,len)) return -1;
-  buf = host.s;
-  case_lowerb(buf,len);
+	if (flagrh < 0) return 0;
 
-  for (j = 0;j < len;++j)
-    if (!j || (buf[j] == '.'))
-      if (constmap(&maprh,buf + j,len - j)) return 1;
-
-  if (fdmrh != -1) {
-    uint32 dlen;
-    int r;
+	j = byte_rchr(buf,len,'@');
+	if (j >= len) return 0; /* envnoathost is not acceptable */
+	++j; buf += j; len -= j;
+
+	if (!stralloc_copyb(&host,buf,len)) return -1;
+	buf = host.s;
+	case_lowerb(buf,len);
+
+	/* if local.cdb available use this as source */
+	if (fdlo != -1) 
+		return cdb_seek(&cdblo, buf, len, &dlen);
+	else   
+		if (constmap(&maplocals, buf, len)) return 1;
+	return 0;
+}
 
-    for (j = 0;j < len;++j)
-      if (!j || (buf[j] == '.')) {
-	r = cdb_seek(fdmrh,buf + j,len - j,&dlen);
-	if (r) return r;
-      }
-  }
+int rcpthosts(char *buf, unsigned int len)
+{
+	unsigned int j;
+	int r;
+	uint32 dlen;
+
+	if (flagrh < 0) return 0;	/* uh-oh init failed so fail too,
+					 * never be a open relay!
+					 */
+
+	j = byte_rchr(buf,len,'@');
+	if (j >= len) return 1; /* presumably envnoathost is acceptable */
+
+	++j; buf += j; len -= j;
+
+	if (!stralloc_copyb(&host,buf,len)) return -1;
+	buf = host.s;
+	case_lowerb(buf,len);
+
+	/* first locals */
+	/* if local.cdb available use this as source */
+	if (fdlo != -1) {
+		r = cdb_seek(&cdblo, buf, len, &dlen);
+		if (r) return r;
+	} else   
+		if (constmap(&maplocals,buf,len)) return 1;
+
+	/* then rcpthosts */
+	for (j = 0;j < len;++j)
+		if (!j || (buf[j] == '.')) {
+			/* if rcpthosts.cdb available use this as source */
+			if (fdrh != -1) {
+				r = cdb_seek(&cdbrh, buf + j, len - j, &dlen);
+				if (r)
+					return r;
+			} else
+				if (constmap(&maprh,buf + j,len - j))
+					return 1;
+		}
+	/* finaly morercpthosts.cdb but only if not rcpthosts.cdb avail */
+	if (fdmrh != -1 && fdrh == -1) {
+		for (j = 0;j < len;++j)
+			if (!j || (buf[j] == '.')) {
+				r = cdb_seek(&cdbmrh,buf + j,len - j,&dlen);
+				if (r)
+					return r;
+			}
+	}
 
-  return 0;
+	return 0;
 }
+
diff -ruN qmail-1.03-orig/rcpthosts.h qmail-1.03-ldap-20060201-orig/rcpthosts.h
--- qmail-1.03-orig/rcpthosts.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/rcpthosts.h	2006-02-25 11:00:56.000000000 +0100
@@ -1,7 +1,8 @@
 #ifndef RCPTHOSTS_H
 #define RCPTHOSTS_H
 
-extern int rcpthosts_init();
-extern int rcpthosts();
+extern int rcpthosts_init(void);
+extern int rcpthosts(char *, unsigned int);
+extern int localhosts(char *, unsigned int);
 
 #endif
